# NBD client library in userspace
# WARNING: THIS FILE IS GENERATED FROM
# generator/generator
# ANY CHANGES YOU MAKE TO THIS FILE WILL BE LOST.
#
# Copyright (C) 2013-2019 Red Hat Inc.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

"""Python bindings for libnbd

import nbd
h = nbd.NBD ()
h.connect_tcp ("localhost", "nbd")
buf = h.pread (512, 0)

Read the libnbd(3) man page to find out how to use the API.
"""

import libnbdmod

AIO_DIRECTION_READ  = 1
AIO_DIRECTION_WRITE = 2
AIO_DIRECTION_BOTH  = 3

CMD_FLAG_FUA = 1<<0

# AIO buffer functions.
def aio_buffer (len):
    """allocate an AIO buffer used for nbd.aio_pread and nbd.aio_pwrite"""
    return libnbdmod.alloc_aio_buffer (len)

def aio_buffer_from_bytearray (ba):
    """create an AIO buffer from a bytearray"""
    return libnbdmod.aio_buffer_from_bytearray (ba)
def aio_buffer_to_bytearray (buf):
    """copy an AIO buffer into a bytearray"""
    return libnbdmod.aio_buffer_to_bytearray (buf)

class NBD (object):
    """NBD handle"""

    def __init__ (self):
        """create a new NBD handle"""
        self._o = libnbdmod.create ()

    def __del__ (self):
        """close the NBD handle and underlying connection"""
        libnbdmod.close (self._o)

    def set_debug (self, debug):
        """set or clear the debug flag"""
        return libnbdmod.set_debug (self._o, debug)

    def get_debug (self):
        """return the state of the debug flag"""
        return libnbdmod.get_debug (self._o)

    def set_debug_callback (self, data, debug_fn):
        """set the debug callback"""
        return libnbdmod.set_debug_callback (self._o, data, debug_fn)

    def set_export_name (self, export_name):
        """set the export name"""
        return libnbdmod.set_export_name (self._o, export_name)

    def get_export_name (self):
        """get the export name"""
        return libnbdmod.get_export_name (self._o)

    def set_tls (self, tls):
        """enable or require TLS (authentication and encryption)"""
        return libnbdmod.set_tls (self._o, tls)

    def get_tls (self):
        """Get the current TLS setting"""
        return libnbdmod.get_tls (self._o)

    def set_tls_certificates (self, dir):
        """set the path to the TLS certificates directory"""
        return libnbdmod.set_tls_certificates (self._o, dir)

    def set_tls_verify_peer (self, verify):
        """set whether we verify the identity of the server"""
        return libnbdmod.set_tls_verify_peer (self._o, verify)

    def get_tls_verify_peer (self):
        """get whether we verify the identity of the server"""
        return libnbdmod.get_tls_verify_peer (self._o)

    def set_tls_username (self, username):
        """set the TLS username"""
        return libnbdmod.set_tls_username (self._o, username)

    def get_tls_username (self):
        """get the current TLS username"""
        return libnbdmod.get_tls_username (self._o)

    def set_tls_psk_file (self, filename):
        """set the TLS Pre-Shared Keys (PSK) filename"""
        return libnbdmod.set_tls_psk_file (self._o, filename)

    def request_meta_context (self, name):
        """request metadata context from the server"""
        return libnbdmod.request_meta_context (self._o, name)

    def connect_unix (self, sockpath):
        """connect to NBD server over a Unix domain socket"""
        return libnbdmod.connect_unix (self._o, sockpath)

    def connect_tcp (self, hostname, port):
        """connect to NBD server over a TCP port"""
        return libnbdmod.connect_tcp (self._o, hostname, port)

    def connect_command (self, argv):
        """connect to NBD server command"""
        return libnbdmod.connect_command (self._o, argv)

    def read_only (self):
        """is the NBD export read-only?"""
        return libnbdmod.read_only (self._o)

    def can_flush (self):
        """does the server support the flush command?"""
        return libnbdmod.can_flush (self._o)

    def can_fua (self):
        """does the server support the FUA flag?"""
        return libnbdmod.can_fua (self._o)

    def is_rotational (self):
        """is the NBD disk rotational (like a disk)?"""
        return libnbdmod.is_rotational (self._o)

    def can_trim (self):
        """does the server support the trim command?"""
        return libnbdmod.can_trim (self._o)

    def can_zero (self):
        """does the server support the zero command?"""
        return libnbdmod.can_zero (self._o)

    def can_multi_conn (self):
        """does the server support multi-conn?"""
        return libnbdmod.can_multi_conn (self._o)

    def can_cache (self):
        """does the server support the cache command?"""
        return libnbdmod.can_cache (self._o)

    def can_meta_context (self, metacontext):
        """does the server support a specific meta context?"""
        return libnbdmod.can_meta_context (self._o, metacontext)

    def get_size (self):
        """return the export size"""
        return libnbdmod.get_size (self._o)

    def pread (self, count, offset):
        """read from the NBD server"""
        return libnbdmod.pread (self._o, count, offset)

    def pwrite (self, buf, offset, flags):
        """write to the NBD server"""
        return libnbdmod.pwrite (self._o, buf, offset, flags)

    def shutdown (self):
        """disconnect from the NBD server"""
        return libnbdmod.shutdown (self._o)

    def flush (self):
        """flushing pending write requests"""
        return libnbdmod.flush (self._o)

    def trim (self, count, offset, flags):
        """send trim to the NBD server"""
        return libnbdmod.trim (self._o, count, offset, flags)

    def cache (self, count, offset):
        """send cache (prefetch) to the NBD server"""
        return libnbdmod.cache (self._o, count, offset)

    def zero (self, count, offset, flags):
        """send write zeroes to the NBD server"""
        return libnbdmod.zero (self._o, count, offset, flags)

    def block_status (self, count, offset, flags, data, extent):
        """read the block status of the given range"""
        return libnbdmod.block_status (self._o, count, offset, flags, data, extent)

    def poll (self, timeout):
        """poll the handle once"""
        return libnbdmod.poll (self._o, timeout)

    def aio_connect (self, addr):
        """connect to the NBD server"""
        return libnbdmod.aio_connect (self._o, addr)

    def aio_connect_tcp (self, hostname, port):
        """connect to the NBD server over a TCP port"""
        return libnbdmod.aio_connect_tcp (self._o, hostname, port)

    def aio_connect_command (self, argv):
        """connect to the NBD server"""
        return libnbdmod.aio_connect_command (self._o, argv)

    def aio_pread (self, buf, offset):
        """read from the NBD server"""
        return libnbdmod.aio_pread (self._o, buf, offset)

    def aio_pwrite (self, buf, offset, flags):
        """write to the NBD server"""
        return libnbdmod.aio_pwrite (self._o, buf, offset, flags)

    def aio_disconnect (self):
        """disconnect from the NBD server"""
        return libnbdmod.aio_disconnect (self._o)

    def aio_flush (self):
        """send flush command to the NBD server"""
        return libnbdmod.aio_flush (self._o)

    def aio_trim (self, count, offset, flags):
        """send trim to the NBD server"""
        return libnbdmod.aio_trim (self._o, count, offset, flags)

    def aio_cache (self, count, offset):
        """send cache (prefetch) to the NBD server"""
        return libnbdmod.aio_cache (self._o, count, offset)

    def aio_zero (self, count, offset, flags):
        """send write zeroes to the NBD server"""
        return libnbdmod.aio_zero (self._o, count, offset, flags)

    def aio_block_status (self, count, offset, flags, data, extent):
        """send block status to the NBD server"""
        return libnbdmod.aio_block_status (self._o, count, offset, flags, data, extent)

    def aio_get_fd (self):
        """return file descriptor associated with this connection"""
        return libnbdmod.aio_get_fd (self._o)

    def aio_get_direction (self):
        """return the read or write direction"""
        return libnbdmod.aio_get_direction (self._o)

    def aio_notify_read (self):
        """notify that the connection is readable"""
        return libnbdmod.aio_notify_read (self._o)

    def aio_notify_write (self):
        """notify that the connection is writable"""
        return libnbdmod.aio_notify_write (self._o)

    def aio_is_created (self):
        """check if the connection has just been created"""
        return libnbdmod.aio_is_created (self._o)

    def aio_is_connecting (self):
        """check if the connection is connecting or handshaking"""
        return libnbdmod.aio_is_connecting (self._o)

    def aio_is_ready (self):
        """check if the connection is in the ready state"""
        return libnbdmod.aio_is_ready (self._o)

    def aio_is_processing (self):
        """check if the connection is processing a command"""
        return libnbdmod.aio_is_processing (self._o)

    def aio_is_dead (self):
        """check if the connection is dead"""
        return libnbdmod.aio_is_dead (self._o)

    def aio_is_closed (self):
        """check if the connection is closed"""
        return libnbdmod.aio_is_closed (self._o)

    def aio_command_completed (self, handle):
        """check if the command completed"""
        return libnbdmod.aio_command_completed (self._o, handle)

    def aio_peek_command_completed (self):
        """check if any command has completed"""
        return libnbdmod.aio_peek_command_completed (self._o)

    def connection_state (self):
        """return a descriptive string for the state of the connection"""
        return libnbdmod.connection_state (self._o)

if __name__ == "__main__":
    import nbd
    import code
    import sys

    h = nbd.NBD ()
    sys.ps1 = "nbd> "

    banner = '''
Welcome to nbdsh, the shell for interacting with
Network Block Device (NBD) servers.

The ‘nbd’ module has already been imported and there
is an open NBD handle called ‘h’.

h.connect_tcp ("remote", "10809")   # Connect to a remote server.
h.get_size ()                       # Get size of the remote disk.
buf = h.pread (512, 0)              # Read the first sector.
exit() or Ctrl-D                    # Quit the shell
'''

    code.interact (banner = banner, local = locals(), exitmsg = '')
